if (LibDebug) then LibDebug() end
local me,ns = ...
local abh=LibStub("AceAddon-3.0"):GetAddon(me)
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
local bs=LibStub("LibBattleScan")
local bg='AV'
local module=abh:GetModule(bg)
local landmarks={18,3,4,19,20,12,16,14,15,11,10,6,21,5,8}
local myevents={
	'GOSSIP_SHOW',
	'QUEST_COMPLETE',
	'QUEST_PROGRESS'
}
local npc={
	L["Smith Regzar"],
	L["Murgot Deepforge"],
	L["Primalist Thurloga"],
	L["Arch Druid Renferal"],
	L["Stormpike Ram Rider Commander"],
	L["Frostwolf Wold Rider Commander"],
	L["Wing Commander Jeztor"],
	L["Wing Commander Guse"],
	L["Wing Commander Mulverick"],
	L["Wing Commander Vipore"],
	L["Wing Commander Slidore"],
	L["Wing Commander Ichman"]
}
local function onclick(widget,event,button)
	if (widget.frame:GetText()==L["Ally Timers"]) then
		module:SpamTimers('Alliance')
	else
		module:SpamTimers('Horde')
	end
end
function module:SpamTimers(faction)
	local frame=self.frame
	for i,row in pairs(frame.children) do
		if row.type=="ABHPoiRow" then
			local icon=row.textureIndex
			if icon and bs:isAssaulted(icon,faction) then
				row:ClickTimer()
			end
		end
	end
end
function module:Init(AceGUI,store)
	self:DashBoard(landmarks,242.5)
	self:SetDoubleButton("avtimers",onclick,L["Ally Timers"],L["Horde Timers"])
	for _,v in pairs (myevents) do
		self:RegisterEvent(v,"Evt" .. v)
	end
end
function module:Config()
	abh:AddToggle("AVSPAM",false,L["Spam your life status"])
	abh:AddSlider("AVSPAMTHRESHOLD",20,10,80,L["Life percentage"],L["Under this life percentage you will start asking for help"])
	--abh:AddToggle("AVBARS",true,"Show status bars for contested nodes","Show a progress bar for contested nodes")
	--abh:AddToggle("AVC",true,"Show commanders info","If enabled, ABH will track commanders' status")
	abh:AddToggle("AVTURNIN",true,L["Auto turn in"],L["If enabled, automatically turns in items for av quests"])

end
function module:Terminate()
	for _,v in pairs (myevents) do
		self:UnregisterEvent(v)
	end
end
function module:EvtGOSSIP_SHOW()
	if (not abh:GetToggle("AVTURNIN")) then
		return
	end
	local target = UnitName("target");
	abh:Debug(target,L["Smith Regzar"],L["Murgot Deepforge"])
	if( target == L["Smith Regzar"] or target == L["Murgot Deepforge"] ) then
		-- Open Quest to Smith or Murgot
		if (GetItemCount(L["Armor Scraps"]) >= 20) then
			SelectGossipAvailableQuest(1);
		end
	elseif( target == L["Primalist Thurloga"]) then
		local n = GetItemCount(L["Stormpike Soldier's Blood"])
		if (n >= 5) then
			SelectGossipAvailableQuest(2);
		elseif (n > 0) then
			SelectGossipAvailableQuest(1);
		end
	
	elseif( target == L["Arch Druid Renferal"]) then
		local n = GetItemCount(L["Storm Crystal"])
		if (n >= 5) then		
			SelectGossipAvailableQuest(2);
		elseif (n > 0) then		
			SelectGossipAvailableQuest(1);
		end
	elseif( target == L["Stormpike Ram Rider Commander"]) then	-- Ram Riders
		if (GetItemCount(L["Frostwolf Hide"]) > 0) then
			SelectGossipAvailableQuest(1);
		end
	
	elseif( target == L["Frostwolf Wold Rider Commander"]) then	-- Wolf Riders
		if (GetItemCount(L["Alterac Ram Hide"]) > 0) then
			SelectGossipAvailableQuest(1);
		end
	end
end
function module:EvtQUEST_PROGRESS()
	if (self.bg ~= "AV") then
		return
	end
	if (not abh:GetToggle("AVTURNIN")) then
		return
	end
	local target = UnitName("target");
	if (target == L["Wing Commander Jeztor"]
		and GetItemCount(L["Stormpike Lieutenant's Flesh"]) == 0) then
	       return;
	elseif (target == L["Wing Commander Guse"]
		and GetItemCount(L["Stormpike Soldier's Flesh"]) == 0) then
	       return;
	elseif (target == L["Wing Commander Mulverick"]
		and GetItemCount(L["Stormpike Commander's Flesh"]) == 0) then
	       return;
	elseif (target == L["Wing Commander Vipore"]
		and GetItemCount(L["Frostwolf Lieutenant's Medal"]) == 0) then
	       return;
	elseif (target == L["Wing Commander Slidore"]
		and GetItemCount(L["Frostwolf Soldier's Medal"]) == 0) then
	       return;
	elseif (target == L["Wing Commander Ichman"]
		and GetItemCount(L["Frostwolf Commander's Medal"]) == 0) then
	       return;
	       end
	       CompleteQuest();
end
function module:EvtQUEST_COMPLETE()
	if (self.bg ~= "AV") then
		return
	end
	if (not abh:GetToggle("AVTURNIN")) then
		return
	end
	local target = UnitName("target");
	for _, value in pairs(npc) do
		if (target == value) then
			GetQuestReward(0);
		end
	end
end