local __FILE__=tostring(debugstack(1,2,0):match("(.*):1:")) -- MUST BE LINE 1
local _,_,_,toc=GetBuildInfo()
local pp=print
--[[
Name: ABH.lua
Revision: $Rev: 227 $
Author: Alar of Daggerspine 
Email: alar@aspide.it
Website: http://www.curse.com
SVN: $HeadUrl:$
License: GPL v2.1
--]]
local me, ns = ...
--[===[@debug@
print("Loading",__FILE__," inside ",me)
--@end-debug@]===]
if (LibDebug) then LibDebug() end
local function debug(...) 
--[===[@debug@
print(...)
--@end-debug@]===]
end
local _G=_G
local print=_G.print
local notify=_G.print
local error=_G.error
local function dump() end
local function debugEnable() end
if (LibStub("AlarLoader-3.0",true)) then
	local rc=LibStub("AlarLoader-3.0"):GetPrintFunctions(me)
	print=rc.print
	--[===[@debug@
	debug=rc.debug
	dump=rc.dump
	--@end-debug@]===]
	notify=rc.notify
	error=rc.error
	debugEnable=rc.debugEnable
else
	debug("Missing AlarLoader-3.0")
end
debugEnable(false)
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
--[[ Standard prologue end --]]

local abh=LibStub("AlarLoader-3.0"):CreateAddon(me)
local frames=LibStub("AlarFrames-3.0")
local C=abh.C
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
local oldZone='none'
local currentBg='none'
local currentModule=nil
local currentName=nil
local startMessages=''
local timerHandle='none'
local GetTime=GetTime
local AceGUI=LibStub("AceGUI-3.0")
local CB=LibStub("LibCandyBar-3.0",true) -- Optional
local soulstoned
local bars={}
local thankspam=240 -- 4 minutes
local qwstatus
local function getSeconds()
	return floor(GetTime())
end
local function store(event,...)
--[===[@debug@
	local msg=currentBg ..' [' .. event .. '] ' .. strjoin(',',tostringall(...))
	tinsert(CLOG,msg)
--@end-debug@]===]		
end

local bs=LibStub("LibBattleScan") 
local function time()
	return math.floor(GetBattlefieldInstanceRunTime()/1000)
end
function abh:OnCommReceived(...)
--[===[@debug@
	print(...)
--@end-debug@]===]
end
function abh:Restore()
	print("Resetting frame")
	if currentModule then currentModule:Reset() end
end
function abh:SmartButton()
	currentModule:SmartButton()
end
function abh:OnInitialized()
	--self:SendCommMessage(me)
	self:RegisterComm(me,"OnCommReceived")
	self:loadHelp(self)
	self.healedyoufor=setmetatable({},{__index=function() return 0 end})
	self.healedyou=setmetatable({},{__index=function() return 0 end})    
	self.localdb=self.db:RegisterNamespace("private")
    self.localdb:RegisterDefaults(
    	{ 
    		profile={
    			frames= {
    				["*"]={}
    			}
    		}
    	}
    )
	local default=not _G.ICU_VERSION
	local autorel=true
	self:PrivateCommands()
	self:AddLabel(L["General"],nil,C.Orange)
	self:AddOpenCmd("restore","Restore",L["Reset frame position to screen center"])
	self:AddAction("restore","Restore",L["Reset frame position to screen center"])
 	self:AddToggle("THANKYOU",false,L["Thanks people who heal you"],L["Incourage people to heal in battlegrounds..... thank them! (It doesnt thank the same one more than once ever 2 minutes)"])
	self:AddToggle("SELFONLY",false,L["Show messages ONLY in your console"],L["If you like to experiment with the various messages without spamming your bg"])
	self:AddToggle("ONSCREEN",true,L["Show bg related messages on screen"],L["Bg related messages are shown in a fading on screen frame"])
	self:AddToggle("AUTOQUESTHIDE",true,L["Auto collapse quest tracker"],L["Will be restored on exit"])
	--self:AddToggle("SYNC",true,C(L["EXPERIMENTAL"],"RED") .. " "..L["Synchronize timers with other ABH users"],L["Disable this if you experiences lag."])
	self:AddToggle("MMAP",default,L["Colorize minimap tooltip and gives info"],L["If enabled, when overing on a minimap tooltip you get it colored according to faction and get class and race"])
	self:AddSlider("IDISTANCE",500,200,1000,L["Base range"],L["The range you are considered to be defending a base"],100)
	-- AB
	self:GetModule('AB'):_Config(L["Arathi Basin"])
	-- WSG
	self:GetModule('WSG'):_Config(L["Warsong Gulch"])
	-- AV
	self:GetModule('AV'):_Config(L["Alterac Valley"])
	-- EOS
	self:GetModule('EOS'):_Config(L["Eye of the Storm"])
	-- SOA
	self:GetModule("SOA"):_Config(L["Strand of the Ancients"])
	-- TP
	self:GetModule("TP"):_Config(L["Twin Peaks"])
	-- BFG
	self:GetModule("BFG"):_Config(L["Battle for Gilneas"])
	-- IOC
	self:GetModule("IOC"):_Config(L["Isle of Conquest"])
	--
	-- WGR
	self:GetModule("WGR"):_Config(L["Wintergrasp"])
	--
	-- WGR
	self:GetModule("TB"):_Config(L["Tol Barad"])
	--
	self:AddLabel(L["KeyBindings"],nil,C.Orange)
	self:AddKeyBinding("SMARTBUTTON",L["Smart Button"],L["Automagically figures the best announce"])

--[[
	for _,s in pairs({L["The battle for Alterac Valley has begun"],L["The Battle for Arathi Basin has begun"],L["Let the battle for Warsong Gulch begin!"],L["The battle has begun"]}) do
	startMessages=startMessages .. "-" .. s
	end
	startMessages=strupper(startMessages)
	--ShortAGen=L["Vanndar Stormpike"]:sub(1,10) .. " : %d%%"
	--ShortHGen=L["Drek'Thar"]:sub(1,10) .. " : %d%%"
--]]
	debugEnable(true)
	
end

function abh:OnEnabled()
	self:RegisterMessage("BATTLESCAN_ENTERED_BATTLEGROUND","BgChanged")
	self:RegisterMessage("BATTLESCAN_LEFT_BATTLEGROUND","BgChanged")
	self:RegisterMessage("BATTLESCAN_BATTLEGROUND_POPUP","BgTimer")
--	self:RegisterMessage("BATTLESCAN_STARTS_IN_SECONDS","BgTimer")	
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:ApplyONSCREEN(self:GetBoolean("ONSCREEN"))
end
function abh:OnDisabled()
	self:UnregisterAllMessages()
end
function abh:BgChanged(event,short,long)
	if (event=="BATTLESCAN_ENTERED_BATTLEGROUND") then
		SetMapToCurrentZone()
		self:EnableBg(short,GetRealZoneText())
	else
		self:EnableBg("NN")
	end
end
function abh:StopBar(handle)
	if (bars[handle]) then
		bars[handle]:Stop()
	end
end
function abh:StopBars()
	for _,bar in pairs(bars) do
		if bar then
			bar:Stop()
		end
	end
	wipe(bars)
end
local function destroyBar(callback,bar)
	local handle=bar:Get('handle')
	if (handle) then
		bars[handle]=nil
	else
	--[===[@debug@
		debug("destroying null bar",bar:Get("handle"))
	--@end-debug@]===]
	end
end
function abh:BarOnClick(bar,...)
	--[===[@debug@
	print("Clicked on bar",bar:Get("handle"),...)
	--@end-debug@]===]
end	
function abh:CreateBar(handle)
	if (not bars[handle]) then
		local bar=CB:New("Interface\\TargetingFrame\\UI-StatusBar",230,20)
		bar:SetIcon("Interface\\GossipFrame\\BattleMasterGossipIcon")
		bar:Set('handle',handle)
		bars[handle]=bar
		CB:RegisterCallback("LibCandyBar_Stop",destroyBar)
		bar:SetScript('OnMouseUp',function(this,...) abh:BarOnClick(this,...) end)
	end
	return bars[handle]
	
end
function abh:BgTimer(event,data,label,stopped,r,g,b)
	--[===[@debug@
	print(event,data)
	--@end-debug@]===]
	if (not CB) then print "Missing CandyBar" return end
	local BgBar
	if (event=="BATTLESCAN_STARTS_IN_SECONDS") then
		BgBar=self:CreateBar(event)
		BgBar:SetDuration(tonumber(data) or 30)
		BgBar:SetLabel(L["Battleground starting in"])
	elseif event=="BATTLESCAN_BATTLEGROUND_POPUP" then
		BgBar=self:CreateBar(event .. tostring(data))
		BgBar:SetDuration(90)
		local status, mapName, instanceID, levelRangeMin, levelRangeMax, teamSize, registeredMatch = GetBattlefieldStatus(data);
		BgBar:SetLabel(tostring(status) .. ' ' .. tostring(mapName))
		BgBar:AddUpdateFunction(function(bar) 
			if not StaticPopup_Visible("CONFIRM_BATTLEFIELD_ENTRY") then
			bar:Stop()
			end
		end)
	else
		BgBar=self:CreateBar(event)
		BgBar:SetDuration(data)
		BgBar:SetLabel(label or 'timer')
	end
	BgBar:SetPoint("CENTER")
	
	BgBar:SetColor(r or 1,g or 0,b or 0)
	if (not stopped) then
		BgBar:Start()
	end
	return BgBar
end
function abh:MoveToCenter(frame,initialdelay)
	local x=frame:GetLeft()*frame:GetEffectiveScale() + frame:GetWidth()*frame:GetEffectiveScale()/2
	local ag=frame:CreateAnimationGroup()
	local move=ag:CreateAnimation('Translation')
	move:SetStartDelay(initialdelay or 10)
	move:SetOffset(frame:GetLeft(),-400)
	move:SetDuration(2)
	move:SetOrder(1)
	local scale=ag:CreateAnimation('Scale')
	scale:SetOrder(2)
	scale:SetScale(1.5)
	scale:SetDuration(1)
	scale:SetEndDelay(7)
	ag:Play()
end
function abh:COMBAT_LOG_EVENT_UNFILTERED(_,timestamp,event,_,sguid,sname,sflags,_,dguid,dname,dflags,spellid,spellname,spellschool,...)
	if (bit.band(COMBATLOG_OBJECT_AFFILIATION_MINE,dflags)==1) then
--sdebug(event,sname,dname,spellid,'(',spellname,')',stack,kind,...)
		if (event == "SPELL_HEAL" ) then
			self:COMBAT_TEXT_UPDATE("COMBAT_TEXT_UPDATE","HEAL",sname,select(1,...))
		end
	end
end

function abh:GetUnitDistance(x,y,unit)
	unit=unit or "player"
	local from={}
	local to={}
	from.x,from.y=GetPlayerMapPosition(unit)
	to.x=x
	to.y=y
	return self:GetDistance(from,to) * 10000
end
function abh:GetDistance(a,b)
	--------------
	-- Calculates distance betweeb 2 points given as
	-- a.x,a.y and b.x,b.y
	local x=b.x - a.x
	local y=b.y -a.y
	local d=x*x + y* y
	local rc,distance=pcall(math.sqrt,d)
	if (rc) then
		return distance
	else
		return 99999
	end
end

function abh:EnableBg(bg,title)
	currentBg=bg
	currentName=title or ''
	for name, module in self:IterateModules() do
		if name ~= currentBg then
			module:Disable()
		end
	end
	if (not self:GetBoolean(strupper(bg))) then
		currentBg='NN'
	else
		self:Print(L['Enabling'],currentBg)
	end
	currentModule=self:GetModule(currentBg)
	currentModule.bg=currentBg
	currentModule:Enable()
	if (currentBg ~= 'NN') then
		self:Description()
		self:RegisterEvent("PLAYER_DEAD")	
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");		
		self.ScheduleRepeatingTimer(currentModule,"MainHeartBeat",1)

	else
		self:CancelAllTimers()
		self:UnregisterEvent("PLAYER_DEAD")	
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");		
	end
end

function abh:Message(msg,channel)
	if (msg) then
		if (self:GetToggle("SELFONLY") or not bs:isInBattlegrounds()) then
			self:Print(msg)
		else
			SendChatMessage(msg,channel or (currentBg=="WGR" and "RAID" or "BATTLEGROUND"))
		end
	end
end
function abh:PLAYER_REGEN_DISABLED(event,...)
	for _,bar in pairs(bars) do
		bar:Hide()
	end
end
function abh:PLAYER_REGEN_ENABLED(event,...)
	for _,bar in pairs(bars) do
		bar:Show()
	end
end
function abh:PLAYER_DEAD()
	self:SetVar(currentBg .. "SPAM",false)
	if (self:GetToggle(currentBg .. "AUTOREL")) then
		for i=1,99 do
			local name,rank,texture=UnitBuff("player",i)
			if not name then break end
			if texture:match("Spell_Shadow_SoulGem") then
				self:Print(L["You are soulstoned, mate"])
				return
			end
		end
		RepopMe()
	end
end
function abh:COMBAT_TEXT_UPDATE(event,tipo,who,amount)
--[===[@debug@
	print(event,tipo,who,amount)
--@end-debug@]===]	
	amount=amount or 0
	if (tipo == "HEAL" or tipo == "HEAL_CRIT" or tipo == "PERIODIC_HEAL") then
		if (who and self:GetBoolean("THANKYOU")) then
			if (not UnitIsUnit(who,"player")) then
				self.healedyoufor[who]=self.healedyoufor[who] + amount
				if (GetTime() - self.healedyou[who] > thankspam) then
					self:Print("%s healed you for %d",who,amount)
					DoEmote("THANK",who)
					self.healedyou[who]=GetTime()
				end
			end
		end
	end
end

local agen=L["Vanndar Stormpike"]
local hgen=L["Drek'Thar"]
abh.prototype={}
_G.CLOG=_G.CLOG or {}
-- Modules definition
do
	local abh=abh
	local prototype=abh.prototype
	local raidStep=1
	function prototype:secs2min(time)
		time=tonumber(time) or 0
		local prefix=''
		if (time < 0) then
			prefix='-'
		end
		time=abs(time)
		return format("%s%d:%02d",prefix,floor(time/60),time % 60)
	end
	local store=store
	local function prefilter(...)
		local me=UnitGUID("player")
		local s=select(4,...)
		local d=select(7,...)
		if (me == s or me == d) then
			store(...)
		end
	end
	local function xcarrier()
		store("carrier")
		store(1,GetBattlefieldFlagPosition(1))
		store(2,GetBattlefieldFlagPosition(2))
	end
	local function xpoi(...)
		store()
		for i=1,GetNumMapLandmarks() do
			store('LANDMARK',i,GetMapLandmarkInfo(i))
		end
		store("ALLIANCE",GetWorldStateUIInfo(1))
		store("HORDE",GetWorldStateUIInfo(2))
	end
	local function xtime()
		store('Elapsed time',GetBattlefieldInstanceRunTime())
	end
	function _G.xstore(...)
		store(...)
	end
	local function IndexToTexCoord(i,l)
	   i=i or 5
	   l=l or 14
	   local c=i%l
	   local dh=1/l
	   local dv=0.5/l
	   local r=i-c
	   local r=r/l
	   local a=floor(c/4)
	   return  c*dh-a*0.005,c*dh+dh-a*0.005,r*dv,r*dv+dv
	end 
	function prototype:ReformatMMTooltip( names )
		local ret = "";
		if( names == nil ) then
			return;
		end
		local wasreturn = false;
		for target in names:gmatch("[^\n]*" ) do
			abh:Debug("RMM",names,target)
			if( target:len() > 0) then
				if (not target:find("%(") ) then
					local name,faction,race,_,class,health,updated=bs:GetInfo(target)
					--colorize names
					local color=C[faction]
					ret=ret .. format("|cff%s%s|r (%s %s h:%s%%)",tostringall(color,target,race,class,health))
				else
					ret=ret .. target
				end
				wasreturn = false;
			else
				if( not wasreturn ) then
					ret = ret .. "\n";
					wasreturn = true;
				end
			end
		end
		return ret
	end	
	function prototype:Print(...)
		abh.Print(self,...)
	end
	function prototype:Init()
	end
	function prototype:DashBoard(landmarks,countdown)
		local status=abh.localdb.profile.frames['BG'..self.bg]
		local frame=self.frame
		frame:SetStatusTable(status)
	    frame:PauseLayout()
--		local tostart=time()-110
--		if (tostart < 0) then
--			abh:BgTimer("BATTLESCAN_STARTS_IN_SECONDS",abs(tostart))
--		end
	    frame:Initialize(self,self.bg,countdown)
	    do
		    local addon=self
		    frame:SetCallback("OnPoiClick",function(... ) addon:PoiClick(select(2,...)) end)
	    end
	    --frame:SetCallback("OnClose",function(widget) widget:Release() end)
		if (type(landmarks) ~= "table") then
		    for i=1,GetNumMapLandmarks() do
		    	frame:AddPoi(i)
		    end
		else
		    for _,i in pairs(landmarks) do
		    	frame:AddPoi(i)
		    end
		   end
	    frame:ResumeLayout()
	    return frame
	end
	function prototype:SetHint(msg)
		self:SetSingleRow("hint",msg)
	end
	function prototype:SetPrediction(winner,time)
		local msg
		if (winner and time>=0 and time <=60*60) then
			time=tonumber(time) or 0
			msg=format(L["%s wins in %s"],winner,self:secs2min(time))
		else
			msg=L["No winner"]
		end
		self:SetSingleRow("prediction",msg)
	end
	function prototype:SetSingleRow(name,msg)
		local frame=self.frame
		if (not frame[name]) then
		local prediction=AceGUI:Create("AlarInteractiveLabel")
			prediction:SetTextAlign("CENTER")
			prediction:SetFullWidth(true)
			frame:AddChild(prediction)
			prediction:SetFullWidth(true)
			prediction:SetCallback("OnClick",function(... ) self:Click(select(2,...)) end)
			frame[name]=prediction
		end
		frame[name]:SetText(msg)	
	end
	function prototype:SetFinals(ally,horde)
		self:SetDoubleRow('finals',ally,horde,46,48)
	end
	function prototype:SetFlags(ally,horde)
		self:SetDoubleRow('flags',ally,horde,43,44)
	end
	function prototype:SetDoubleRow(name,ally,horde,allyicon,hordeicon)
		ally=ally or 0
		horde=horde or 0
		allyicon=allyicon or 46
		hordeicon=hordeicon or 48
		local frame=self.frame
		if (not frame[name]) then
			local g=AceGUI:Create("SimpleGroup")
			g:SetLayout("Flow")
			g:SetFullWidth(true)
			local l=AceGUI:Create("AlarLabel")
			local r=AceGUI:Create("AlarLabel")
			l:SetImageSize(16,16)
			r:SetImageSize(16,16)
			l:SetImage('interface\\minimap\\poiicons',IndexToTexCoord(allyicon))
			r:SetImage('interface\\minimap\\poiicons',IndexToTexCoord(hordeicon))
			r:SetImageAlign("RIGHT")
			r:SetTextAlign("RIGHT")
			l:SetRelativeWidth(0.50)
			r:SetRelativeWidth(0.50)
			g.a=l
			g.h=r
			g:AddChildren(l,r)
			frame:AddChild(g)
			frame[name]=g
		end
		frame[name].a:SetText(ally)
		frame[name].h:SetText(horde)
	end
	function prototype:SetDoubleButton(name,onclick,left,right)
		local frame=self.frame
		if (not frame[name]) then
			local g=AceGUI:Create("SimpleGroup")
			g:SetLayout("Flow")
			g:SetFullWidth(true)
			local l=AceGUI:Create("Button")
			local r=AceGUI:Create("Button")
			l:SetRelativeWidth(0.50)
			r:SetRelativeWidth(0.50)
			g.l=l
			g.r=r
			g:AddChildren(l,r)
			frame:AddChild(g)
			frame[name]=g
			if (type(onclick)=="function") then
				l:SetCallback("OnClick",onclick)
				r:SetCallback("OnClick",onclick)
			end
		end
		frame[name].l:SetText(left)
		frame[name].r:SetText(right)
	end
	function prototype:Terminate()
	end
	function prototype:ApplySCALE(value)
		if true then return end
		local frame=self.frame.frame
		value=tonumber(value) or 0.8
		if value >1 then value=1 end
		local y=frame:GetTop()
		local x=frame:GetRight()-frame:GetWidth()
		local s=frame:GetEffectiveScale()
		y=y*s
		x=x*s
		frame:ClearAllPoints()
		frame:SetScale(value)
		frame:SetClampedToScreen(true)
		s=frame:GetEffectiveScale()
		x=x/s
		y=y/s
		frame:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",x,y)
	end
	function prototype:Super()
		return prototype
	end
	function prototype:_Config(long)
		local short=self.bg
		abh:AddLabel(short,long .. " " .. L["Related options"],C.Green)
		abh:AddToggle(short,true,"Enable","Enable " .. long)
		abh:AddToggle(short..'AUTOREL',true,L["Autorelease"],L["Enables autorelease in"].." " ..long)
		--abh:AddSlider(short.."SCALE",0.8,0.5,1,L["Scale main frame"],L["Change the scaling of WSG panel to fit your layout"],0.05)
		self:Config(short,long)
	end
	function prototype:Config(short,long)
	end
	function prototype:Refresh(...)
		if (self.frame) then
			self.frame:Refresh()
			self.frame:SetTitle((self.title or '') .. ' ' .. self:secs2min(time()-110))
			abh:Description(self.title)
			self:UpdateStates()
		end
	end
	function prototype:UpdateStates()
	end
	function prototype:Apply(key,value)
	end
	function prototype:SmartButton(howmany)
		local node=bs:GetNearestNode()
		if (node) then
			local base=node.name
			local msg
			--msg=format(L["%s now safe"],base);
			--msg=format(L["Massive inc to %s"], base)
			--msg=format(L["On my way to %s. Hold on!"],base)
			msg=format(L["Help needed at %s"],base .. ' (' .. GetSubZoneText()..')')
		else
			msg=format(L["Help needed at %s"], GetSubZoneText())
		end
		abh:Message(msg)
	end
	function prototype:MainHeartBeat()
		--raidScanStep()
		self:HeartBeat()
		self:Refresh()
    	if( abh:GetToggle("MMAP") and GetMouseFocus() ) then
    	   if(MouseIsOver(Minimap)and GetMouseFocus():GetName()=="Minimap") then
            local tt=GameTooltipTextLeft1:GetText()
        		if (tt) then
        			GameTooltipTextLeft1:SetText(self:ReformatMMTooltip(tt));
        			GameTooltip:Show();
        		end
            end
    	end		
	end
	function prototype:HeartBeat()
	end
	function prototype:Reset()
		if (self.frame) then
			self.frame:ClearAllPoints()
			self.frame:SetPoint("CENTER")
		end
	end
	function prototype:OnEnable()
		RequestBattlefieldScoreData()
		self:RegisterEvent("UPDATE_WORLD_STATES",function(...) self:Refresh(...) end)
		bs:EventsOn()
		self.frame=AceGUI:Create("AbhPanel")
		local frame=self.frame
		frame:SetStatusTable(abh.localdb.profile.frames["BG" .. self.bg ])
		frame:ApplyStatus()
		local BG=strupper(self.bg)
		self.title=GetRealZoneText()
	    frame:SetTitle(self.title )
	    abh:Description(self.title)		
		self:ApplySCALE(abh:GetNumber(BG.."SCALE",0.8))
		_G[BG]=self.frame		
		self:Init(AceGUI,store)
		self:RegisterMessage("BATTLESCAN_NODE_CHANGED","RefreshNode")
		self:Refresh()
		if (abh:GetToggle("AUTOQUESTHIDE")) then
			qwstatus=_G.WatchFrame.collapsed
			if (not qwstatus) then
				_G.WatchFrameCollapseExpandButton:Click()
			end
		end
	end
	function prototype:RefreshNode(event,node)
--[===[@debug@
		print("Refreshing ",node)
--@end-debug@]===]		
		self.frame:Reset(node)
	end
	function prototype:OnDisable()
		self:UnregisterAllEvents()
		self:UnregisterAllMessages()
		self.frame:ReleaseChildren()
		pcall(AceGUI.Release,AceGUI,self.frame)
		abh:StopBars()
		if abh:GetToggle("AUTOQUESTHIDE") then
			if qwstatus ~= _G.WatchFrame.collapsed then
				_G.WatchFrameCollapseExpandButton:Click()		
			end
		end
		self:Terminate()
	end
	function prototype:Click(event,button,msg)
		self:Message(msg or "","BATTLEGROUND")
	end
	function prototype:PoiClick(event,button,type,msg,row)
		local x,y,base,icon=row.x,row.y,row.name,row.textureIndex
		if type=="label" then
			if (button == "MiddleButton") then
				msg=format(L["%s now safe"],base);
			elseif (button == "RightButton") then
				msg=format(L["Massive inc to %s"], base)
			else
				if (IsShiftKeyDown() or not abh:IsInRange(x,y)) then
					msg=format(L["On my way to %s. Hold on!"],base)
				else
					msg=format(L["Help needed at %s"],base)
				end
			end
		elseif type=="timer" then
			msg=format(L["%s -> %s in %s"],bs:isAllianceAssaulted(icon) and FACTION_ALLIANCE or FACTION_HORDE,base or 'unk',msg or 'dunno')
		end
		self:Message(msg or "","BATTLEGROUND")
		local px,py=GetPlayerMapPosition("player")
--[===[@debug@		
		debug("You are ",abh:GetUnitDistance(x,y),x,px,y,py)
--@end-debug@]===]
	end	
	function prototype:Message(msg,channel)
	    if (msg) then
		    if (abh:GetToggle("SELFONLY")or not bs:isInBattlegrounds()) then
		    	abh:Print(msg)
			else
				SendChatMessage(msg,channel or "BATTLEGROUND")
			end
		end
	end
	LibStub("AceConsole-3.0"):RegisterChatCommand('xpoi',xpoi)
	LibStub("AceConsole-3.0"):RegisterChatCommand('xtime',xtime)
	LibStub("AceConsole-3.0"):RegisterChatCommand('xcarrier',xcarrier)
	LibStub("AceConsole-3.0"):RegisterChatCommand('xstore',xstore)

end
for _,bg in pairs(bs:GetShorts()) do
	local module=abh:NewModule(bg,abh.prototype,"AceEvent-3.0","AceTimer-3.0")
	module:Disable()
	module.bg=bg
end
_G['ABH']=abh
local module=abh:NewModule('NN', abh.prototype)
module.bg="NN"
function module:OnEnable()
	
end
function module:Init()
end
function module:OnDisable()
end
function module:Apply()
end
function module:SmartButton()
	self:Print(L["You are not in a battleground"])
end
--------------------------------- Apply Functions -----------------------------------------
function abh:ApplyWSGNOTIFY(value)
	ns.wsgnotify=value
end

function abh:ApplyTHANKYOU(value)
	ns.thankyou=value
end

function abh:ApplyAVC(value)

end

function abh:ApplyGUESSER(value)
	ns.guesser=value
	if (not value) then
		self.bgdata={}
	end
end
function abh:ApplyONSCREEN(value)
	if (value) then
		self:RegisterMessage("BATTLESCAN_CHAT_MESSAGE","OnScreenIt")
	else
		self:UnregisterMessage("BATTLESCAN_CHAT_MESSAGE",true)
	end
end
function abh:OnScreenIt(event,faction,message)
	if self:GetToggle("ONSCREEN") then
		self:OnScreen(faction, message )
	end
end
function abh:ApplySYNC(value)
	ns.synchro=value
end
function abh:Apply(key,value)
	for k,_ in pairs(bs:GetShorts()) do
		if key==k then
			bs:Refresh()
			return
		end
	end
	if (key == currentBg .. "SCALE") then
		currentModule:ApplySCALE(value)
		return
	end
	if (currentModule) then
		currentModule:Apply(key,value)
	end
	
end
function abh:IsInRange(x,y,unit)
	local distance=self:GetUnitDistance(x,y,unit or "player")
	return distance < (self:GetNumber("IDISTANCE") or 300)
end
function abh:PrivateCommands()
		
end
--_G.BINDING_HEADER_ALARBGHELPER=me
--@do-not-package@

do
	local hflagstatus,hresources,aflagstatus,aresources,hflags,aflags=0,0,0,0,0,0
	local resource1
	local resource2
	local abases,hbases=0,0
	local rates={}
	local module
	local bg
	local nodestates={
		[16]=" aAhH", -- Gold Mine
		[21]=" aAhH", -- Lumber Mill
		[26]=" aAhH", -- Blacksmith
		[31]=" aAhH", -- Farm
		[36]=" aAhH", -- Stables
	}
	local nodestatus={
	" "," "," "," "," "
	}
	local ofuncs={
	GetWorldStateUIInfo=GetWorldStateUIInfo,
	GetMapLandmarkInfo=GetMapLandmarkInfo,
	GetNumMapLandmarks=GetNumMapLandmarks
	}
	local lfuncs={
	GetWorldStateUIInfo=function (f)
		if (f==bs:HordeUI()) then
			if (bg=="WSG") then
				return 1,hflagstatus+1,format("%d/3",hflags)
			else
				return 1,hflagstatus+1,format("%d %d/1600",hbases,hresources)
			end
		else
			if (bg=="WSG") then
				return 1,aflagstatus+1,format("%d/3",aflags)
			else
				return 1,aflagstatus+1,format("%d %d/1600",abases,aresources)
			end
		end
	end,
	GetMapLandmarkInfo= function(i)
		local basenode=i*5+11
		local basestates=nodestates[basenode]
		local basestatus=nodestatus[i]
		--local icon=basestates:find(basestatus)+basenode-1
		return "Base " .. i ,"Descrizione",i,i*0.1,i*0.1
	end,	
	GetNumMapLandmarks=function ()
		return 28
	end
	}
	local function cbInfo()
		if (bg=="WSG") then
			print("AFlags",aflags)
			print("HFlags",hflags)
			print("Astatus",aflagstatus)
			print("Hstatus",hflagstatus)
		else
			for k,v in pairs(nodestates) do
				print(k,":",v)
			end
		end
	end
	function abh:Fake(data)
		bg=data or 'AB'
		bg=strupper(bg)
		self:Print("Faking",bg)
		for k,f in pairs(ofuncs) do
			_G[k]=lfuncs[k]
		end
		rates=bs:GetRates('AB')
		if (bg=="AB") then
			bs:CheckZone("ArathiBasin")
		else
			bs:CheckZone("WarsongGulch")
		end
		bs:Push('hordeplayer',1,1,1,'Horde',3,'Orc','mage','MAGE',1,2,100,floor(GetTime()))
		bs:Push('allyplayer',1,1,1,'Alliance',3,'Dwarf','mage','MAGE',1,2,100,floor(GetTime()))
		self:EnableBg(bg)
		module=self:GetModule(bg)
		self:ShowPanel(bg)
	end
	function abh:Unfake()
		self:EnableBg("NN")
		for k,f in pairs(ofuncs) do
			_G[k]=ofuncs[k]
		end
	end
	function abh:ShowDb()
		LibStub("LibBattleScan"):ShowCache() 

	end
	

	local function cbResource(this)
		hbases=0
		abases=0
		for _,i in pairs(nodestatus) do
			if (i=="A") then abases=abases+1 end
			if (i=="H") then hbases=hbases+1 end
		end
		hresources=hresources+rates[hbases] *15
		aresources=aresources+rates[abases] *15
		local _,state,text=GetWorldStateUIInfo(bs:HordeUI())
		resource1:SetText(format("Flag %d Horde: %s",state,text))
		local _,state,text=GetWorldStateUIInfo(bs:AllianceUI())
		resource2:SetText(format("Flag %d Ally : %s",state,text))
	end
	local function fire(faction,actor,message)
		cbResource()
		bs:EventHandler(faction,"CHAT_MSG_BG_SYSTEM_"..faction,message,'p1','p2','p3',actor)
		module:Refresh()
	end
	local function cbHorde(this,event,button)
		local index=this:GetUserData("index")
		if (index==0) then
			if button=="LeftButton" then
				aflagstatus=aflagstatus+1
				if (aflagstatus==2) then hflags=hflags+1 end				
				fire("HORDE","_hordeplayer_",aflagstatus==1 and "The Alliance flag was picked up by hordeplayer!" or "hordeplayer captured the Alliance flag!")
				aflagstatus=aflagstatus %2

			else
				if (aflagstatus==1) then
					aflagstatus=0
					fire("ALLIANCE","_hordeplayer_","The Alliance Flag was dropped by hordeplayer")
				else
					fire("ALLIANCE","_allyplayer_","The Horde flag was returned to its base by allyplayer")
				end
			end
			return
		end
		local status=nodestatus[index]
		local msg="Hordeplayer [" .. status
		
		if (status==' ' or status=='A') then
			status="h"
			msg=msg.."h] ha assaltato "
		elseif (status=="a" or status=="h") then
			msg=(status=="a" and "H] ha difeso" or "H] ha catturato")
			status="H"
		else
			msg=" non ha fatto nulla"
		end
		nodestatus[index]=status
		fire("HORDE",nil,msg .. GetMapLandmarkInfo(index))
	end
	local function cbAlliance(this,event,button)
		local index=this:GetUserData("index")
		if (index==0) then
			if button=="LeftButton" then
				hflagstatus=hflagstatus+1
				if (hflagstatus==2) then aflags=aflags+1 end
				fire("ALLIANCE","_allyplayer_",hflagstatus==1 and "The Horde flag was picked up by allyplayer!" or "allyplayer captured the Horde flag!")
				hflagstatus=hflagstatus %2
			else
				if (hflagstatus==1) then
					hflagstatus=0
					fire("HORDE","_allyplayer_","The Horde Flag was dropped by allyplayer!")
				else
					fire("HORDE","_hordeplayer_","The Horde flag was returned to its base by hordeplayer")
				end
			end
			return
		end
		local status=nodestatus[index]
		local msg="Allyplayer [" .. status
		
		if (status==' ' or status=='H') then
			status="a"
			msg=msg.."a] ha assaltato "
		elseif (status=="a" or status=="h") then
			msg=(status=="a" and "A] ha difeso" or "A] ha catturato")
			status="A"
		else
			msg=" non ha fatto nulla"
		end
		nodestatus[index]=status
		fire("ALLIANCE",nil,msg .. GetMapLandmarkInfo(index))
	end

	function abh:ShowPanel(bg)
		local w=AceGUI:Create("Window")
		resource1=AceGUI:Create("AlarLabel")
		resource1:SetTextAlign("CENTER")
		resource1:SetText("Horde")
		resource2=AceGUI:Create("AlarLabel")
		resource2:SetTextAlign("CENTER")
		resource2:SetText("Alliance")
		local b3=AceGUI:Create("Button")
		b3:SetCallback("OnClick",cbResource)
		b3:SetText("Resource")
		w:AddChildren(resource1,resource2,b3)
		if (bg=="WSG") then
			local b1=AceGUI:Create("Button")
			b1:SetCallback("OnClick",cbHorde)
			b1:SetText("Horde")
			b1:SetUserData("index",0)
			local b2=AceGUI:Create("Button")
			b2:SetCallback("OnClick",cbAlliance)
			b2:SetText("Alliance")
			b2:SetUserData("index",0)
			b1.frame:RegisterForClicks("AnyUp")
			b2.frame:RegisterForClicks("AnyUp")
			w:AddChildren(b1,b2)
		else
			for i=1,GetNumMapLandmarks() do
				local g=AceGUI:Create("SimpleGroup")
				g:SetLayout("Flow")
				local name,desc,index,x,y=GetMapLandmarkInfo(i)
				local l=AceGUI:Create("Label")
				l:SetWidth(70)
				l:SetText(name)
				local b1=AceGUI:Create("Button")
				b1:SetWidth(70)
				b1:SetCallback("OnClick",cbHorde)
				b1:SetText("Horde")
				b1:SetUserData("index",i)
				local b2=AceGUI:Create("Button")
				b2:SetWidth(70)
				b2:SetCallback("OnClick",cbAlliance)
				b2:SetText("Alliance")
				b2:SetUserData("index",i)
				g:AddChildren(l,b1,b2)
				w:AddChild(g)
			end
		end
		local b4=AceGUI:Create("Button")
		b4:SetCallback("OnClick",cbInfo)
		b4:SetText("Info")
		b3.frame:RegisterForClicks("AnyUp")
		b4.frame:RegisterForClicks("AnyUp")
		w:AddChild(b4)
		w:SetHeight(400)
		w:SetWidth(250)
	end
end	

--]]
--@end-do-not-packaged@
--WatchFrameCollapseExpandButton